﻿local VendorCostAutorepair,vv = ...;

local GetItemInfo = GetItemInfo;
local GetNumQuestChoices = GetNumQuestChoices;
local GetQuestItemLink = GetQuestItemLink;
local select = select;

vv.frame = CreateFrame("Frame");
vv.frame:SetScript("OnEvent",function(self,event,...)
	if QuestFrameRewardPanel:IsShown() then
		vv.reward();
	end
end);
vv.frame:RegisterEvent("QUEST_COMPLETE");
vv.frame:RegisterEvent("QUEST_ITEM_UPDATE");

function vv.reward()
	local price,id;
	for i=1,GetNumQuestChoices() do
		local link = GetQuestItemLink("choice",i);
		if link then
			local item = select(11,GetItemInfo(link)) or 0;
			if (not price) or (item > price) then
				price = item;
				id = i;
			end
		end
	end
	if id then
		QuestInfoItem_OnClick(_G["QuestInfoItem"..id]);
	end
end

-- Config
local guildRepair = false -- Always use guild repair (false) or always use own money (true)
local guildOnlyRaid = true -- Guild repair ONLY while in a raid group
local printMessage = true -- Prints how much the repair was

--  The goods
local rm = CreateFrame("Frame", "VendorCostAutorepair")
rm:RegisterEvent("MERCHANT_SHOW")
rm:SetScript("OnEvent", function()
	local cost = GetRepairAllCost()
	local function gr()
		if printMessage then
			if cost > 1e4 then
				print(format("Repaired from the guild bank for %d|cffffd700g|r %d|cffc7c7cfs|r %d|cffeda55fc|r", cost / 1e4, mod(cost, 1e4) / 1e2, mod(cost, 1e2)))
			elseif cost > 1e2 then
				print(format("Repaired from the guild bank for %d|cffc7c7cfs|r %d|cffeda55fc|r", cost / 1e2, mod(cost, 1e2)))
			else
				print(format("Repaired from the guild bank for %d|cffeda55fc|r", cost))
			end
		end
		RepairAllItems(1)
	end
	local function sr()
		if printMessage then
			if cost > 1e4 then
				print(format("Repaired for %d|cffffd700g|r %d|cffc7c7cfs|r %d|cffeda55fc|r", cost / 1e4, mod(cost, 1e4) / 1e2, mod(cost, 1e2)))
			elseif cost > 1e2 then
				print(format("Repaired for %d|cffc7c7cfs|r %d|cffeda55fc|r", cost / 1e2, mod(cost, 1e2)))
			else
				print(format("Repaired for %d|cffeda55fc|r", cost))
			end
		end
		RepairAllItems()
	end
	if IsModifierKeyDown() then
		return
	elseif CanMerchantRepair() and cost ~= 0 then
		if guildRepair and CanGuildBankRepair() and cost <= GetGuildBankMoney() and (cost <= GetGuildBankWithdrawMoney() or GetGuildBankWithdrawMoney() == -1) then
			if guildOnlyRaid and GetNumRaidMembers() ~= 0 then
				gr()
			elseif not guildOnlyRaid then
				gr()
			elseif cost <= GetMoney() then
				sr()
			else
				print("Not enough money to automatically repair")
			end
		elseif cost <= GetMoney() then
			sr()
		else
			print("Not enough money to automatically repair")
		end
	end
end)